﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinToolbars


Public Class Inicio

    Private moToolsWidth As New Dictionary(Of String, Integer)


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try

            Me.Cursor = Cursors.WaitCursor

            utmMenu.ResetAppearance()
            utmMenu.ResetMenuSettings()
            utmMenu.ResetToolbarSettings()

            Dim rtSaraMon As New RibbonTab("tabMonitorizacion", "Pestaña de prueba")
            rtSaraMon.Settings.Appearance.Image = "img-014.png"
            utmMenu.Ribbon.Tabs.Add(rtSaraMon)

            Dim grupoFiltrosCondiciones As New RibbonGroup("grupoFiltrosCondiciones", "Grupo de prueba")
            utmMenu.Ribbon.Tabs("tabMonitorizacion").Groups.Add(grupoFiltrosCondiciones)

            grupoFiltrosCondiciones.PreferredToolSize = RibbonToolSize.Normal
            grupoFiltrosCondiciones.LayoutDirection = RibbonGroupToolLayoutDirection.Vertical
            grupoFiltrosCondiciones.LayoutAlignment = RibbonGroupLayoutAlignment.Far

            Application.DoEvents()

            ' Grupos ---------------------------------------------------------------------------------------------------------------

            CreateLabelTool(utmMenu, "lblCuentaTotalGrupo", "1111", 50)
            CreateLabelTool(utmMenu, "lblDescGrupo", "Grupo", 40)
            Dim uddGrupoMaquinas As PopupMenuTool = CreatePopupMenuTool(utmMenu, "uddGrupoMaquinas", Nothing, -1, -1)
            CreateButtonTool(utmMenu, "btnQuitarGrupo", "")

            grupoFiltrosCondiciones.Tools.AddTool("lblCuentaTotalGrupo")
            grupoFiltrosCondiciones.Tools.AddTool("lblDescGrupo")
            grupoFiltrosCondiciones.Tools.AddTool("uddGrupoMaquinas")
            grupoFiltrosCondiciones.Tools.AddTool("btnQuitarGrupo")

            grupoFiltrosCondiciones.Tools("lblCuentaTotalGrupo").InstanceProps.ButtonGroup = 0
            grupoFiltrosCondiciones.Tools("lblDescGrupo").InstanceProps.ButtonGroup = 0
            grupoFiltrosCondiciones.Tools("uddGrupoMaquinas").InstanceProps.ButtonGroup = 0
            grupoFiltrosCondiciones.Tools("btnQuitarGrupo").InstanceProps.ButtonGroup = 0

            ' Filtros --------------------------------------------------------------------------------------------------------------

            CreateLabelTool(utmMenu, "lblCuentaTotalFiltro", "2222", 50)
            CreateLabelTool(utmMenu, "lblDescFiltro", "Filtro", 40)
            Dim uddFiltro As PopupMenuTool = CreatePopupMenuTool(utmMenu, "uddFiltro", Nothing, -1, -1)
            CreateButtonTool(utmMenu, "btnQuitarCondicion", "")

            grupoFiltrosCondiciones.Tools.AddTool("lblCuentaTotalFiltro")
            grupoFiltrosCondiciones.Tools.AddTool("lblDescFiltro")
            grupoFiltrosCondiciones.Tools.AddTool("btnQuitarCondicion")
            grupoFiltrosCondiciones.Tools.AddTool("uddFiltro")

            grupoFiltrosCondiciones.Tools("lblCuentaTotalFiltro").InstanceProps.ButtonGroup = 1
            grupoFiltrosCondiciones.Tools("lblDescFiltro").InstanceProps.ButtonGroup = 1
            grupoFiltrosCondiciones.Tools("uddFiltro").InstanceProps.ButtonGroup = 1
            grupoFiltrosCondiciones.Tools("btnQuitarCondicion").InstanceProps.ButtonGroup = 1

            ' Resumen --------------------------------------------------------------------------------------------------------------

            CreateLabelTool(utmMenu, "lblCuentaMaquinasGrupo", "3333", 50)
            CreateLabelTool(utmMenu, "lblMaquinasGrupo", "Máquinas analizadas según criterios indicados", 290)
            CreateButtonTool(utmMenu, "btnQuitarGrupoYCondicion", "")

            grupoFiltrosCondiciones.Tools.AddTool("lblCuentaMaquinasGrupo")
            grupoFiltrosCondiciones.Tools.AddTool("lblMaquinasGrupo")
            grupoFiltrosCondiciones.Tools.AddTool("btnQuitarGrupoYCondicion")

            grupoFiltrosCondiciones.Tools("lblCuentaMaquinasGrupo").InstanceProps.ButtonGroup = 2
            grupoFiltrosCondiciones.Tools("lblMaquinasGrupo").InstanceProps.ButtonGroup = 2
            grupoFiltrosCondiciones.Tools("btnQuitarGrupoYCondicion").InstanceProps.ButtonGroup = 2


            ' Botón Aplicar Grupos y Condiciones -----------------------------------------------------------------------------------

            CreateButtonTool(utmMenu, "btnAplicarCriterios", "Aplicar")
            grupoFiltrosCondiciones.Tools.AddTool("btnAplicarCriterios")

            utmMenu.Tools("btnAplicarCriterios").SharedProps.AllowMultipleInstances = False
            grupoFiltrosCondiciones.Tools("btnAplicarCriterios").InstanceProps.PreferredSizeOnRibbon = RibbonToolSize.Large
            grupoFiltrosCondiciones.Tools("btnAplicarCriterios").InstanceProps.IsFirstInGroup = True


            moToolsWidth.Add("uddFiltro", 150)
            moToolsWidth.Add("uddGrupoMaquinas", 150)
            utmMenu.CreationFilter = New MyPopupMenuTool(moToolsWidth)

        Catch ex As Exception ' ---------------------------------------------------------------------------------------------------
            MessageBox.Show(ex.Message, "WARNING", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally ' ----------------------------------------------------------------------------------------------------------------
            Me.Cursor = Cursors.Default
        End Try

    End Sub

    Friend Function CreateLabelTool(ByVal poBarraMenus As Infragistics.Win.UltraWinToolbars.UltraToolbarsManager _
                                    , ByVal psKey As String, ByVal psTexto As String, ByVal pnAncho As Integer) As Infragistics.Win.UltraWinToolbars.LabelTool

        Dim ltNuevo As Infragistics.Win.UltraWinToolbars.LabelTool

        ltNuevo = New Infragistics.Win.UltraWinToolbars.LabelTool(psKey)
        ltNuevo.SharedProps.Caption = psTexto

        ltNuevo.SharedProps.Width = pnAncho
        ltNuevo.SharedProps.MinWidth = pnAncho
        ltNuevo.SharedProps.MaxWidth = pnAncho

        ltNuevo.SharedProps.DisplayStyle = UltraWinToolbars.ToolDisplayStyle.TextOnlyAlways

        poBarraMenus.Tools.Add(ltNuevo)
        Return ltNuevo

    End Function

    Friend Function CreatePopupMenuTool(ByVal poBarraMenus As UltraToolbarsManager, ByVal psKey As String, ByVal psTexto As String _
                                    , ByVal pnSmallImageIndex As Integer, ByVal pnLargeImageIndex As Integer _
                                    , Optional ByVal psAyuda As String = Nothing, Optional ByVal poImagen As Bitmap = Nothing) As PopupMenuTool

        Dim btNuevo As PopupMenuTool

        Try

            btNuevo = New PopupMenuTool(psKey)
            btNuevo.SharedProps.Caption = psTexto

            If Not IsNothing(psAyuda) Then btNuevo.SharedProps.ToolTipText = psAyuda

            If Not IsNothing(poImagen) Then

                btNuevo.SharedProps.AppearancesSmall.Appearance.Image = poImagen
                btNuevo.SharedProps.AppearancesLarge.Appearance.Image = poImagen

            Else

                If pnSmallImageIndex >= 0 Then btNuevo.SharedProps.AppearancesSmall.Appearance.Image = "img-" & pnSmallImageIndex.ToString("000") & ".png"
                If pnLargeImageIndex >= 0 Then btNuevo.SharedProps.AppearancesLarge.Appearance.Image = "img-" & pnLargeImageIndex.ToString("000") & ".png"

            End If

            poBarraMenus.Tools.Add(btNuevo)
            Return btNuevo

        Catch ex As Exception ' ---------------------------------------------------------------------------------------------------
            MessageBox.Show(ex.Message, "WARNING", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return Nothing

        End Try

    End Function

    Friend Function CreateButtonTool(ByVal poBarraMenus As UltraToolbarsManager, ByVal psKey As String, ByVal psTexto As String) As ButtonTool

        Dim btNuevo As ButtonTool

        Try

            Dim toolImageSmall As Bitmap = CreateDummyToolBitmap(16, 16, Color.Blue)

            btNuevo = New ButtonTool(psKey)
            btNuevo.SharedProps.Caption = psTexto
            btNuevo.SharedProps.AppearancesSmall.Appearance.Image = toolImageSmall
            btNuevo.SharedProps.AppearancesSmall.Appearance.ImageHAlign = HAlign.Center
            btNuevo.SharedProps.AppearancesSmall.Appearance.ImageVAlign = VAlign.Middle
            poBarraMenus.Tools.Add(btNuevo)
            Return btNuevo

        Catch ex As Exception ' ---------------------------------------------------------------------------------------------------
            MessageBox.Show(ex.Message, "WARNING", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return Nothing
        End Try

    End Function

    Friend Function CreateDummyToolBitmap(ByVal width As Integer, ByVal height As Integer, ByVal color As Color) As Bitmap

        Dim dummyToolBitmap As Bitmap = New Bitmap(width, height)
        Dim g As Graphics = Graphics.FromImage(dummyToolBitmap)
        g.Clear(color)
        g.DrawRectangle(Pens.Black, 0, 0, width - 1, height - 1)
        g.Dispose()

        Return dummyToolBitmap

    End Function

End Class
