﻿Imports Infragistics.Win.UltraWinToolbars
Imports Infragistics.Win


Public Class MyPopupMenuTool
    Implements Infragistics.Win.IUIElementCreationFilter


    Private _toolswidth As New Dictionary(Of String, Integer)


    Public Sub New(ByVal poToolsWidth As Dictionary(Of String, Integer))

        _toolswidth = poToolsWidth

    End Sub

#Region "IUIElementCreationFilter Members"

    Public Sub AfterCreateChildElements(ByVal parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements

        If TypeOf parent Is PopupToolUIElement Then

            Dim pop As PopupToolUIElement = parent

            If Not IsNothing(pop) Then

                Dim toolwidth As IEnumerable(Of Integer) = From entry In _toolswidth Where entry.Key = pop.Tool.Key Select entry.Value

                If toolwidth.Count() > 0 Then

                    If TypeOf pop.Parent Is RibbonButtonGroupUIElement Then
                        pop.Rect = New Rectangle(pop.Rect.Location, New Size(_toolswidth(pop.Tool.Key), pop.Rect.Size.Height))
                    End If

                    If TypeOf pop.Parent Is RibbonGroupUIElement Then
                        pop.Rect = New Rectangle(pop.Rect.Location, New Size(_toolswidth(pop.Tool.Key), pop.Rect.Size.Height))
                    End If

                End If


            End If

        End If

    End Sub

    Public Function BeforeCreateChildElements(ByVal parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        ' return false so PositionChildElements will get called 
        ' to do the default child element creation
        Return False
    End Function

#End Region

End Class
